Page MenuHomePhabricator

RTL language characters are displayed in LTR order in LTR languages (and vice versa)
Closed, ResolvedPublic

Description

Incorrect reversed display of non Latin characters

Please see the attached image and Bugs #54308 & #54309.

By this time I resigned to utilize the advanced toolbar and after making an attempt, I feel very cynical because this effort is totally useless. There is a lot to be said for programmers and developers learning to proofread a chapter or so of text, to see how their ideas are working in the real world.

In the first place, It takes several steps to hide the header to gain additional viewing space or access various features.

Finally, The non-Latin characters, like Hebrew and Arabic were inserted from left to right. For those who don't understand, that's the equivalent of displaying Latin characters from right to left, as in: . . . . L K J I H G F E D C B A

In view of my previous posts, please consider correcting this ASAP.


Version: unspecified
Severity: normal

Attached:

Details

Reference
bz54310
Related Gerrit Patches:
mediawiki/extensions/WikiEditor : masterUse display:inline-block for special character buttons
mediawiki/extensions/VisualEditor : masterfetchSpecialCharList: Set directionality
mediawiki/extensions/VisualEditor : masterUpdate VE core submodule to master (f5c88eb30)
VisualEditor/VisualEditor : masterSpecialCharacterPage: Allow setting lang/dir via special attributes property

Event Timeline

bzimport raised the priority of this task from to Low.Nov 22 2014, 2:00 AM
bzimport added a project: WikiEditor.
bzimport set Reference to bz54310.
bzimport added a subscriber: Unknown Object (MLST).
Ineuw created this task.Sep 19 2013, 8:31 AM

Confirming what you see. Hebrew letters Alef and Bet are on the left.

I am pretty sure that this is intended and that it depends on your personal language settings in https://en.wikisource.org/wiki/Special:Preferences#mw-prefsection-personal-i18n because depending on your "primary" language you are used to either expect the first letter on the left (LTR) or on the right (RTL).

It's the same the other way round:
Looking at the Cyrillic character section with the interface language set to Hebrew (by simply adding &uselang=he to the URL), I also get the Russian alphabet from right to left, while Russian is a left to right language.

Ineuw added a comment.Sep 19 2013, 8:43 PM

Andre, the user's language settings should not affect the character sets. They should be displayed in their natural order regardless of the user's language preferences.

Reopening: I looked at en.wikipedia and de.wikipedia. Both have a set of special characters *below* the editbox, which isn't part of MediaWiki, but developed by the communities. In both cases the characters of RTL languages are shown from right to left, so even if this behavior of WikiEditor is intended (which I doubt), it is wrong based on the expectation of its users.

Michael M., Please point me to the page on en.Wikipedia where RTL characters show up correctly. I just implemented the WikiEditor on en. Wikipedia and RTL characters were displayed in LTR order. Then, I am curious as to how do you know what is the expectation of the users???

yesod22 wrote:

Hi. The only input I can give is that as a bi-lingual english hebrew speaker being forced with the option of having english displayed RTL or hebrew displayed LTR is CERTAINLY not desired. I'd much prefer having each language displayed in it's natural order - as it's supposed to be.

The idea of displaying Hebrew or Arabic from LTR because that's the expectation of an english speaker reminds me of a joke by Louis CK on how the pilgrims named the natives "Indians" despite the fact that they had nothing to do with India :-) (see youtube). A language should be displayed in it's order - not in the order of what a non-native speaker would like it to be :-)

blessings, Daniel

Restricted Application added a project: I18n. · View Herald TranscriptJun 2 2015, 2:20 PM
Ebraminio moved this task from Backlog to MediaWiki-core on the RTL board.Aug 9 2015, 9:20 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 9 2015, 9:20 PM

Change 414961 had a related patch set uploaded (by Amire80; owner: Amire80):
[mediawiki/extensions/WikiEditor@master] Order right-to-left alphabets from right-to-left in the special character selector

https://gerrit.wikimedia.org/r/414961

Amire80 moved this task from Untriaged to RTL on the I18n board.Feb 27 2018, 7:59 AM
Amire80 added a subscriber: Amire80.

I set the CSS float to right for RTL languages.

If this is done for WikiEditor, then it must also be updated in the VE special character editor. There is will be easier: the lang and dir attributes must simply set on the <div> that wraps all the characters <span> tags.

Change 415281 had a related patch set uploaded (by Esanders; owner: Esanders):
[VisualEditor/VisualEditor@master] SpecialCharacterPage: Allow setting lang/dir via special attributes property

https://gerrit.wikimedia.org/r/415281

Change 415286 had a related patch set uploaded (by Esanders; owner: Esanders):
[mediawiki/extensions/VisualEditor@master] fetchSpecialCharList: Set directionality

https://gerrit.wikimedia.org/r/415286

Change 415281 merged by jenkins-bot:
[VisualEditor/VisualEditor@master] SpecialCharacterPage: Allow setting lang/dir via special attributes property

https://gerrit.wikimedia.org/r/415281

Change 415374 had a related patch set uploaded (by Jforrester; owner: Jforrester):
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (bdb1a680a)

https://gerrit.wikimedia.org/r/415374

Change 415374 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Update VE core submodule to master (f5c88eb30)

https://gerrit.wikimedia.org/r/415374

Change 415286 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] fetchSpecialCharList: Set directionality

https://gerrit.wikimedia.org/r/415286

Change 414961 merged by jenkins-bot:
[mediawiki/extensions/WikiEditor@master] Use display:inline-block for special character buttons

https://gerrit.wikimedia.org/r/414961

Deskana closed this task as Resolved.Mar 8 2018, 10:33 AM
happy5214 moved this task from Backlog to Closed on the WikiEditor board.Aug 4 2019, 11:39 AM